#
#	
#                                     	
#
#
#



# -*- encoding: cp1251 -*-
from Tkinter import *
from tkFileDialog import *
import cp1251

from site_checker import *

def w2u(str):
	return unicode(str,"cp1251")

class C_ui:
	def __init__(self):
		self.init_ui()
	
	def init_ui(self):
		self.root = Tk()
		#
		self.opts_bar = Frame(self.root)
		self.opts_bar.config(height = 40, bd = 2, relief = RIDGE)		
		
		self.start_dir__lbl = Label(self.opts_bar)
		self.start_dir__lbl.config(text = w2u(" "))
		self.start_dir__lbl.grid(sticky = W)
	
		self.level__lbl = Label(self.opts_bar)
		self.level__lbl.config(text = w2u('   '))
		self.level__lbl.grid(columnspan = 2, sticky = W)
		
		self.start_dir = StringVar()
		self.start_dir.set(".")
		self.start_dir__ent = Entry(self.opts_bar)
		self.start_dir__ent.config(highlightbackground = "#777", bg = "#ffffff", bd = 1, textvariable = self.start_dir)
		self.start_dir__ent.grid(row = 0, column = 1, pady = 2, padx = 2, columnspan = 2, sticky = W+E)
		
		self.sel_dir_dlg__btn = Button(self.opts_bar)
		self.sel_dir_dlg__btn.config(text = w2u(''), command = self.browse)
		self.sel_dir_dlg__btn.grid(row = 0, column = 3, sticky = W+E)
		
		self.level = StringVar()
		self.level.set("0")
		self.level__ent = Entry(self.opts_bar)
		self.level__ent.config(highlightbackground = "#777", bg = "#ffffff", bd = 1, textvariable = self.level, width = 6)
		self.level__ent.grid(row = 1, column = 2, pady = 2, padx = 2)
	
		
		self.go__btn = Button(self.opts_bar)
		self.go__btn.config(text = w2u(''), command=self.go ) 
		self.go__btn.grid(row = 1, column = 3, pady = 2)
		
		self.check_external = IntVar()
		#self.check_external__ckbx = Checkbutton(self.opts_bar)
		#self.check_external__ckbx.config(text = w2u('  '), variable = self.check_external)
		#self.check_external__ckbx.grid(row = 2, column = 1, columnspan = 3)
		self.check_external.set(0)

		self.opts_bar.grid(sticky = W)
		

		self.save__btn = Button(self.root)
		self.save__btn.config(text = w2u(''), command = self.save)
		self.save__btn.grid(row = 0, column = 1)

		self.exit__btn = Button(self.root)
		self.exit__btn.config(text = w2u(''), command = self.close_ui)
		self.exit__btn.grid(row = 0, column = 2)
		

		self.text__frm = Frame(self.root)
		

		self.text_x__scrl = Scrollbar(self.text__frm)
		self.text_y__scrl = Scrollbar(self.text__frm)
		
		self.text__txt = Text(self.text__frm)
		self.text__txt.config(height = 20, state=NORMAL, relief=RIDGE, wrap=NONE, xscrollcommand=self.text_x__scrl.set , yscrollcommand = self.text_y__scrl.set)
		self.text__txt.config(state = DISABLED)
		self.text__txt.grid(sticky = N+E+W+S)

		self.text_y__scrl.config(command = self.text__txt.yview, orient = VERTICAL)
		self.text_y__scrl.grid(row = 0, column = 1, sticky = N+S+E)

		self.text_x__scrl.config(command = self.text__txt.xview, orient = HORIZONTAL)
		self.text_x__scrl.grid(row = 1, column = 0, sticky = E+W+S)
		
		self.text__frm.grid(row = 1, column = 0, columnspan=3,sticky = E+W+S)

		self.root.protocol("WM_DELETE_WINDOW", self.close_ui)
		self.root.title("site checker")
		self.root.resizable(0, 0)

	def scroll_x(self,arg):
		self.text__txt.xview(SCROLL, arg)
		print arg
	
	def scroll_y(self,arg):
		self.text__txt.yview(SCROLL, arg)
		print arg
	
	def browse(self):
		#d = LoadFileDialog(self.root)
		#options['initaldir'] = self.start_dir.get()
		p = askdirectory(initialdir = self.start_dir.get(), mustexist = 1)
		if (p):
			self.start_dir.set(p)
			#print p

	def walk_dir(self,path, level, ck_ext):
		err = list()
		if level < 1 :
			site = C_site_checker(path)
			site.check_external = ck_ext
			err.append("\n __________ " + path + ' __________ ')

			struct_errs = " \n"
			img_size_info = "  \n"
			dir_size_info = "  \n"
			links_errs = " \n"
			external_link_info = " \n"
			errs = list()
			errs.extend(site.check_structure())
			errs.extend(site.check_integrity())		

			for e in errs:
				#try:
				e_type , e_str  = e
				#except:
				#	print e
				if e_type == 'struct error':
					struct_errs += "\t" + e_str + "\n"
				if e_type == 'link error':
					links_errs += "\t" + e_str + "\n"
				if e_type == 'dir info':
					dir_size_info += "\t" + e_str + "\n"
				if e_type == 'external link info':
					external_link_info += "\t" + e_str + "\n"
				if e_type == 'image info':
					img_size_info += "\t" + e_str + "\n"
			
			err.append(struct_errs[:-1])
			err.append(links_errs[:-1])
			err.append(external_link_info[:-1])
			err.append(img_size_info[:-1])
			err.append(dir_size_info[:-1])
			
	


		else:
			for name in glob.glob(os.path.join(path, '*')):
				if os.path.isdir(name):
					err.extend(self.walk_dir(os.path.join(path, name), level - 1, ck_ext))
		return err

	def go(self):
		path = self.start_dir.get()
		level = string.atoi(self.level.get())
		
		errs = list() 
		errs = self.walk_dir(path, level, self.check_external.get())
		self.data = string.join(errs,'\n')
		self.text__txt.config(state = NORMAL)
		self.text__txt.delete(1.0, END)
		self.text__txt.insert(END, w2u(self.data))
		self.text__txt.config(state = DISABLED)
		

	def save(self):
		file = asksaveasfile(filetypes = [ ('all files', '*') ] )
		if file :
			file.write(self.data)
			file.close
		
	def close_ui(self):
		self.root.destroy()
	
	def run(self):
		self.root.mainloop()
	
import locale

locale.setlocale(locale.LC_ALL, '')
if os.path.supports_unicode_filenames :
	print "unicode filenames supported"
else:
	print "unicode filenames not supported"


ui = C_ui()
ui.run()
